 import { world, EquipmentSlot, system } from '@minecraft/server';

world.beforeEvents.chatSend.subscribe(async (data) => {
  let source = data.sender;
  if (data.message.toLowerCase() === '-swap') {
    data.cancel = true;
    system.run(() => {
      const offhand = source.getComponent('minecraft:equipment_inventory');
      const offhandItem = offhand.getEquipment(EquipmentSlot.offhand);
      const container = source.getComponent('minecraft:inventory').container;
      const mainhand = container.getSlot(source.selectedSlot);
      const mainhandItem = container.getItem(source.selectedSlot);
      
      if (!mainhandItem) return; // It will return undefined if the player has no item in its mainhand
      
      offhand.setEquipment(EquipmentSlot.offhand, mainhandItem);
      source.playSound('armor.equip_generic');
      mainhand.setItem(offhandItem);
    });
  }
});

